package com.pointrlabs.sample.splash

import android.content.Context
import android.util.AttributeSet
import kotlin.jvm.JvmOverloads
import android.widget.FrameLayout
import android.view.animation.Animation
import com.pointrlabs.core.R
import android.view.Gravity
import android.view.animation.AnimationUtils
import android.widget.ImageView

class PointrProgressSpinner @JvmOverloads constructor(
    context: Context?,
    attrs: AttributeSet? = null,
    defStyleAttr: Int = 0
) : FrameLayout(
    context!!, attrs, defStyleAttr
) {
    private val outerCircle: ImageView
    private val innerCircle: ImageView
    private val counterClockWiseRotation: Animation
    private val clockWiseRotation: Animation

    init {
        outerCircle = ImageView(context)
        outerCircle.setImageResource(R.drawable.ic_logo_outer_arc)
        val lpOuter = LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT)
        lpOuter.gravity = Gravity.CENTER
        outerCircle.layoutParams = lpOuter
        addView(outerCircle)
        innerCircle = ImageView(context)
        innerCircle.setImageResource(R.drawable.ic_logo_inner_arc)
        val lpInner = LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT)
        lpInner.gravity = Gravity.CENTER
        innerCircle.layoutParams = lpInner
        addView(innerCircle)
        val pin = ImageView(context)
        pin.setImageResource(R.drawable.ic_logo_indicator)
        val lpPin = LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT)
        lpPin.gravity = Gravity.CENTER
        pin.layoutParams = lpPin
        addView(pin)
        clockWiseRotation = AnimationUtils.loadAnimation(context, R.anim.rotate_cw)
        counterClockWiseRotation = AnimationUtils.loadAnimation(context, R.anim.rotate_ccw)
    }

    fun show() {
        visibility = VISIBLE
        outerCircle.startAnimation(clockWiseRotation)
        innerCircle.startAnimation(counterClockWiseRotation)
    }

    fun hide() {
        outerCircle.clearAnimation()
        innerCircle.clearAnimation()
        visibility = GONE
    }
}